CREATE OR REPLACE function arc2arcs_02_del_non_ex_risk
(
  src_environment in numeric(31),
  dest_environment in numeric(31)
)
return numeric(31) is

begin
  --cancelliamo i risk_type non presenti nel sistema sorgente
  delete from risk_type t_dest where not exists
  (
    select 1 from &IGA_CORE_USER_OLD..risk_type t_src where
      t_src.id = t_dest.id
      and t_src.environment = src_environment
  )
  and t_dest.environment = dest_environment;

  --cancelliamo i risk non presenti nel sistema sorgente
  delete from risk t_dest where not exists
  (
    select 1 from &IGA_CORE_USER_OLD..risk t_src where
      t_src.id = t_dest.id
      and t_src.environment = src_environment
  )
  and t_dest.environment = dest_environment;

  --cancelliamo i risk presenti nel sistema sorgente
  --con stesso CODE e ID diverso
  delete from risk t_dest where exists
  (
    select 1 from &IGA_CORE_USER_OLD..risk t_src where
      t_src.id <> t_dest.id
      and lower ( t_src.name ) = lower ( t_dest.name )
      and t_src.environment = src_environment
  )
  and t_dest.environment = dest_environment;

  --cancelliamo i risk_task non presenti nel sistema sorgente
  delete from risk_task t_dest where not exists
  (
    select 1 from &IGA_CORE_USER_OLD..risk_task t_src where
      t_src.environment = src_environment
      and t_src.risk = t_dest.risk
      and t_src.task = t_dest.task
  )
  and t_dest.environment = dest_environment;

  return 0;
end arc2arcs_02_del_non_ex_risk;
/
