CREATE OR REPLACE function arc2arcs_02_ins_mis_risk
(
  src_environment in numeric(31),
  dest_environment in numeric(31)
)
return numeric(31) is

begin
  --inseriamo i risk_type mancanti nel sistema destinazione
  --ATTENZIONE:
  --LA QUERY DI RICERCA DELLE DIFFERENZE AVVIENE SU ***TUTTI***
  --I CAMPI TRANNE ENVIRONMENT
  --SE VENGONO AGGIUNTI CAMPI IN PIU SULLA TABELLA O SE SI VUOLE
  --DISABILITARE IL CONTROLLO SU QUALCHE CAMPO BISOGNA AGIRE QUI
  insert into risk_type
    (environment, id, name)
  select
    dest_environment, t_src.id, t_src.name
  from &IGA_CORE_USER_OLD..risk_type t_src where not exists
  (
    select 1 from risk_type t_dest where
      t_src.id = t_dest.id
      and t_dest.environment = dest_environment
  )
  and t_src.environment = src_environment;

  --inseriamo i risk mancanti nel sistema destinazione
  --ATTENZIONE:
  --LA QUERY DI RICERCA DELLE DIFFERENZE AVVIENE SU ***TUTTI***
  --I CAMPI TRANNE ENVIRONMENT
  --SE VENGONO AGGIUNTI CAMPI IN PIU SULLA TABELLA O SE SI VUOLE
  --DISABILITARE IL CONTROLLO SU QUALCHE CAMPO BISOGNA AGIRE QUI
  insert into risk
    (environment, id, name, value, description, state,
     attr1, attr2, attr3, attr4, attr5, last_mod_user,
     last_mod_time, risk_level, risk_type, impact, likelihood,
     tolerance, trend, accept_rational, /*owner,*/ ownercode,
     creation_user, creation_date, scope_visibility)
  select
     dest_environment, t_src.id, t_src.name, t_src.value, t_src.description, t_src.state,
     t_src.attr1, t_src.attr2, t_src.attr3, t_src.attr4, t_src.attr5, t_src.last_mod_user,
     t_src.last_mod_time, t_src.risk_level, t_src.risk_type, t_src.impact, t_src.likelihood,
     t_src.tolerance, t_src.trend, t_src.accept_rational, /*t_src.owner,*/ t_src.ownercode,
     t_src.creation_user, t_src.creation_date, t_src.scope_visibility
  from &IGA_CORE_USER_OLD..risk t_src where not exists
  (
    select 1 from risk t_dest where
      t_src.id = t_dest.id
      and t_dest.environment = dest_environment
  )
  and t_src.environment = src_environment;

  --inseriamo i risk mancanti nel sistema destinazione
  --ATTENZIONE:
  --LA QUERY DI RICERCA DELLE DIFFERENZE AVVIENE SU ***TUTTI***
  --I CAMPI TRANNE ENVIRONMENT
  --SE VENGONO AGGIUNTI CAMPI IN PIU SULLA TABELLA O SE SI VUOLE
  --DISABILITARE IL CONTROLLO SU QUALCHE CAMPO BISOGNA AGIRE QUI
  insert into risk_task
    (environment, risk, task, hier)
  select
    dest_environment, t_src.risk, t_src.task, t_src.hier
  from &IGA_CORE_USER_OLD..risk_task t_src where not exists
  (
    select 1 from risk_task t_dest where
      t_dest.environment = dest_environment
      and t_src.risk = t_dest.risk
      and t_src.task = t_dest.task
  )
  and t_src.environment = src_environment;

  return 0;
end arc2arcs_02_ins_mis_risk;
/
