declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Entitlement. Assigned Reports';
  rq_desc          varchar(512) := 'Reports assignment to Entitlements';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select distinct r.name as REPORT_NAME,
'||'                e1.name as ENTITLEMENT_NAME,
'||'                case
'||'                  when e1.ext_type = 3 then ''Permission''
'||'                  when e1.ext_type = 4 then ''External Role''
'||'                  when e1.int_type = 2 then ''IT Role''
'||'                  when e1.int_type = 3 then ''Business Role''
'||'                end as ENTITLEMENT_TYPE
'||'  from #pmschema#.entitlement_hier eh,
'||'       #pmschema#.entitlement      e,
'||'       #schema#.report                     r,
'||'       #pmschema#.entitlement      e1
'||' where r.id = cast ( e.attr5 as numeric(31) )
'||'   and e.id = eh.child
'||'   and e1.id = eh.parent
';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
