declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Export Tech Transformation';
  rq_desc          varchar(512) := 'This export tool produce a downloadable xlsx file containing the complete Technical transformation data associated to an environment. Usually, Export is used to migrate a configuration from one deployment to another (in conjunction this its brother "Import" tool), or to create a backup of your system.';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select distinct t.pg_id,
'||'                t.pg_name,
'||'                t.pg_root,
'||'                t.pg_parent,
'||'                t.pg_type,
'||'                t.pg_cond,
'||'                t.pg_prof,
'||'                t.pg_attr,
'||'                t.pg_value,
'||'                t.ent_id,
'||'                t.ent_name,
'||'                t.ent_int_type,
'||'                t.ent_app_name,
'||'                t.ent_prof_type_name,
'||'                t.ent_tp_link,
'||'                t.ent_task_code,
'||'                t.ent_task_env_name,
'||'                t.serv_prof_id,
'||'                t.serv_id,
'||'                t.serv_name,
'||'                t.serv_value
'||'from
'||'(
'||'  select distinct pg.id                          as pg_id,
'||'                  pg.name                        as pg_name,
'||'                  pg.root                        as pg_root,
'||'                  pg.parent                      as pg_parent,
'||'                  pg.type                        as pg_type,
'||'                  pg.condition                   as pg_cond,
'||'                  pg.profile                     as pg_prof,
'||'                  pg.attribute                   as pg_attr,
'||'                  pg.value                       as pg_value,
'||'                  cast ( null as numeric(31) )        as ent_id,
'||'                  cast ( null as varchar(256) ) as ent_name,
'||'                  cast ( null as numeric(31) )        as ent_int_type,
'||'                  cast ( null as varchar(256) ) as ent_app_name,
'||'                  cast ( null as varchar(256) ) as ent_prof_type_name,
'||'                  cast ( null as varchar(256) ) as ent_tp_link,
'||'                  cast ( null as varchar(256) ) as ent_task_code,
'||'                  cast ( null as varchar(256) ) as ent_task_env_name,
'||'                  cast ( null as numeric(31) )        as serv_prof_id,
'||'                  cast ( null as numeric(31) )        as serv_id,
'||'                  cast ( null as varchar(256) ) as serv_name,
'||'                  cast ( null as varchar(256) ) as serv_value,
'||'                  env.working                    as env_working
'||'    from #pmschema#.profile_group pg,
'||'         #pmschema#.profile_group pgr,
'||'         #pmschema#.task_profile  tp,
'||'         #pmschema#.environment   env
'||'   where pgr.root = pg.root
'||'     and pgr.profile = tp.profile
'||'     and tp.environment = env.id
'||'     and pgr.type = 5
'||'  union
'||'  select distinct cast ( null as numeric(31) )        as pg_id,
'||'                  cast ( null as varchar(256) ) as pg_name,
'||'                  cast ( null as numeric(31) )        as pg_root,
'||'                  cast ( null as numeric(31) )        as pg_parent,
'||'                  cast ( null as numeric(31) )        as pg_type,
'||'                  cast ( null as numeric(31) )        as pg_cond,
'||'                  cast ( null as numeric(31) )        as pg_prof,
'||'                  cast ( null as numeric(31) )        as pg_attr,
'||'                  cast ( null as varchar(256) ) as pg_value,
'||'                  e.id                           as ent_id,
'||'                  e.name                         as ent_name,
'||'                  e.int_type                     as ent_int_type,
'||'                  a.name                         as ent_app_name,
'||'                  pt.name                        as ent_prof_type_name,
'||'                  tp.tp_link                     as ent_tp_link,
'||'                  t.code                         as ent_task_code,
'||'                  env.name                       as ent_task_env_name,
'||'                  cast ( null as numeric(31) )        as serv_prof_id,
'||'                  cast ( null as numeric(31) )        as serv_id,
'||'                  cast ( null as varchar(256) ) as serv_name,
'||'                  cast ( null as varchar(256) ) as serv_value,
'||'                  env.working                    as env_working
'||'    from (select tp.task, tp.profile, tp.environment, ''DIR'' as tp_link
'||'            from #pmschema#.task_profile tp
'||'          union
'||'          select tp.task, pgp.profile, tp.environment, ''PG'' as tp_link
'||'            from #pmschema#.profile_group pg,
'||'                 #pmschema#.profile_group pgp,
'||'                 #pmschema#.task_profile  tp
'||'           where pg.root = pgp.root
'||'             and pg.type = 5
'||'             and pg.profile = tp.profile
'||'             and pgp.type < 5
'||'             and pgp.profile is not null) tp
'||'    left outer join #pmschema#.environment env on tp.environment = env.id
'||'    left outer join #pmschema#.task t on tp.task = t.id
'||'                                     and env.id = t.environment
'||'    left outer join #pmschema#.entitlement e on tp.profile = e.id
'||'    left outer join #pmschema#.application a on e.application = a.id
'||'    left outer join #pmschema#.profile_type pt on e.profile_type = pt.id
'||'                                              and pt.application = a.id
'||'   where e.int_type in (-1, 0, 1)
'||'  union
'||'  select distinct cast ( null as numeric(31) )        as pg_id,
'||'                  cast ( null as varchar(256) ) as pg_name,
'||'                  cast ( null as numeric(31) )        as pg_root,
'||'                  cast ( null as numeric(31) )        as pg_parent,
'||'                  cast ( null as numeric(31) )        as pg_type,
'||'                  cast ( null as numeric(31) )        as pg_cond,
'||'                  cast ( null as numeric(31) )        as pg_prof,
'||'                  cast ( null as numeric(31) )        as pg_attr,
'||'                  cast ( null as varchar(256) ) as pg_value,
'||'                  cast ( null as numeric(31) )        as ent_id,
'||'                  cast ( null as varchar(256) ) as ent_name,
'||'                  cast ( null as numeric(31) )        as ent_int_type,
'||'                  cast ( null as varchar(256) ) as ent_app_name,
'||'                  cast ( null as varchar(256) ) as ent_prof_type_name,
'||'                  cast ( null as varchar(256) ) as ent_tp_link,
'||'                  cast ( null as varchar(256) ) as ent_task_code,
'||'                  cast ( null as varchar(256) ) as ent_task_env_name,
'||'                  pgs.profile                    as serv_prof_id,
'||'                  pga.attribute                  as serv_id,
'||'                  sa.name                        as serv_name,
'||'                  sa.value                       as serv_value,
'||'                  env.working                    as env_working
'||'    from #pmschema#.profile_group     pg,
'||'         #pmschema#.profile_group     pga,
'||'         #pmschema#.profile_group     pgs,
'||'         #pmschema#.task_profile      tp,
'||'         #pmschema#.environment       env,
'||'         #pmschema#.service_attribute sa
'||'   where pg.root = pga.root
'||'     and pga.root = pgs.root
'||'     and pg.type = 5
'||'     and pg.profile = tp.profile
'||'     and tp.environment = env.id
'||'     and pga.type < 5
'||'     and pgs.profile is not null
'||'     and pga.attribute is not null
'||'     and pga.attribute = sa.id
'||'     and pga.parent = pgs.id
'||') t
'||'where t.env_working = 1
'||'order by t.pg_root, t.pg_id, t.ent_int_type, t.ent_id, t.serv_id';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
