declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'SAP Authorization and Business Activity Catalog';
  rq_desc          varchar(512) := '';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select a.name SAP_SYSTEM_NAME,
'||'       p.transaction_name as SAP_AUTHORIZATION_NAME,
'||'       p.description as SAP_AUTHORIZATION_DESC,
'||'       ( t.path || ''/'' || t.name ) as ACTIVITY_NAME,
'||'       ( t.id - cast ( ''#arcs_sod_code#'' as numeric(31) ) ) as SOD_CODE
'||'  from #ccsschema#.entitlement  p,
'||'       #ccsschema#.task_profile tp,
'||'       #ccsschema#.task         t,
'||'       #ccsschema#.environment  e,
'||'       #ccsschema#.application  a
'||' where p.id = tp.profile
'||'   and p.int_type = 1
'||'   and tp.task = t.id
'||'   and lower ( e.name ) = lower( ''#environment_name#'' )
'||'   and e.id = tp.environment
'||'   and tp.environment = t.environment
'||'   and p.application = a.id
'||'   and lower ( a.name ) = lower ( ''#sap_system_name#'' )
';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
