declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'SAP Role and Business Activity Catalog';
  rq_desc          varchar(512) := '';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select a.name as SAP_SYSTEM_NAME,
'||'       it.name as SAP_ROLE_NAME,
'||'       it.description as SAP_ROLE_DESC,
'||'       pr.name as SAP_AUTHORIZATION_NAME,
'||'       pr.TRANSACTION_NAME as SAP_TRANSACTION_NAME,
'||'       ( tk.path || ''/'' || tk.name ) as ACTIVITY_NAME,
'||'       ( tk.id - cast ( ''#arcs_sod_code#'' as numeric(31) ) ) as SOD_CODE
'||'  from #ccsschema#.entitlement           it,
'||'       #ccsschema#.entitlement_family    itf,
'||'       #ccsschema#.entitlement_flat_hier itpr,
'||'       #ccsschema#.entitlement           pr,
'||'       #ccsschema#.task_profile          tp,
'||'       #ccsschema#.task                  tk,
'||'       #ccsschema#.environment           e,
'||'       #ccsschema#.application           a
'||' where it.family = itf.id
'||'   and lower ( itf.name ) = lower ( ''SAP Role'' )
'||'   and it.application = a.id
'||'   and a.id = pr.application
'||'   and lower ( a.name ) = lower ( ''#sap_system_name#'' )
'||'   and it.id = itpr.parent
'||'   and itpr.child = pr.id
'||'   and itpr.child_int_type = 1
'||'   and pr.id = tp.profile
'||'   and lower ( e.name ) = lower ( ''#environment_name#'' )
'||'   and e.id = tp.environment
'||'   and tp.environment = tk.environment
'||'   and tp.task = tk.id
'||'   and lower ( it.name ) like lower ( ''#sap_role_name#'' )
';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
