CREATE OR REPLACE function event_11_res_add
(
  v_eventpm in out eventpm%rowtype,
  v_user_erc_id in numeric(31),
  v_state in numeric(31),
  v_trace in varchar(4000),
  v_cod_operation in varchar(4000),
  v_priority in numeric(31)
)
return numeric(31) is
-- operation 14 - Aggiunta risorsa
/*
  MAPPATURA EVENTPM in CASO DI AGGIUNTA/RIMOZIONE RISORSE
  person         = person.id
  cod_operation  = code_operation
  operation      = operation
  entity         = resource.id
  attr1          = resource.name
  attr2          = resource_type.name
  attr3          = resource_family.name
  attr4          = entilement.name
  attr5          = person_resource.id
  pwdcfg         = entilement.id
*/
  pr_rec          person_resource%ROWTYPE;

  counter         numeric(16);
  v_eventpm_attr5 numeric(16);

  v_acc_user_code   varchar(256);
begin
  v_eventpm_attr5 := cast(v_eventpm.attr5 as numeric(31));

  select count(1)
    into counter
    from entitlement t
   where t.id = v_eventpm.pwdcfg;

  if ( counter = 0 ) then
    return event_01_del_fb_per_res ( v_eventpm_attr5, v_eventpm.operation );
  end if;

  select t.name
    into pr_rec.entitlement_name
    from entitlement t
   where t.id = v_eventpm.pwdcfg;

  --controlliamo se la risorsa cui ci si riferisce  stata cancellata
  select count(1)
    into counter
    from resourc r, resource_type rt, resource_family rf
   where r.resource_type = rt.id
     and rt.resource_family = rf.id
     and r.id = v_eventpm.entity;

  if ( counter = 0 ) then
    --2011/04/14 - Se la risorsa assegnata non esiste non si propaga e si esce
    return event_01_del_fb_per_res ( v_eventpm_attr5, v_eventpm.operation );
  end if;

  select r.name, rt.name, rf.name
    into pr_rec.resource_name, pr_rec.resource_type_name, pr_rec.resource_fam_name
    from resourc r, resource_type rt, resource_family rf
   where r.resource_type = rt.id
     and rt.resource_family = rf.id
     and r.id = v_eventpm.entity;

  v_eventpm.attr1 := pr_rec.resource_name;
  v_eventpm.attr2 := pr_rec.resource_type_name;
  v_eventpm.attr3 := pr_rec.resource_fam_name;
  v_eventpm.attr4 := pr_rec.entitlement_name;

  update person_resource
     set entitlement_name   = pr_rec.entitlement_name,
         resource_name      = pr_rec.resource_name,
         resource_type_name = pr_rec.resource_type_name,
         resource_fam_name  = pr_rec.resource_fam_name
   where id = v_eventpm_attr5;

  update feedback
     set user_erc    = v_user_erc_id,
         funct       = pr_rec.resource_name,
         funct_type  = pr_rec.resource_type_name
   where authorizations = v_eventpm_attr5
     and operation = v_eventpm.operation;

  select count(1)
    into counter
    from person_resource pr
   where pr.id < v_eventpm_attr5 -- controlliamo se in precedenza (id minore di quello attuale) la risorsa  stata gi assegnata all'utente
     and pr.resourc = v_eventpm.entity
     and pr.person = v_eventpm.person;

  v_acc_user_code := event_02_user_acc_code ( v_eventpm.pwdcfg, v_eventpm.person );

  --non  pi necessario controllare che la risorsa in oggetto non sia la "ALL" poich
  --il controllo  fatto in precedenza
  if ( counter = 0 ) then
    return event_01_res_add_rem ( v_eventpm, v_user_erc_id, v_state, v_trace, v_cod_operation, v_priority, v_acc_user_code );
  else
    return -1;
  end if;
end event_11_res_add;
/
