CREATE OR REPLACE function event_11_res_rem
(
  v_eventpm in out eventpm%rowtype,
  v_user_erc_id in numeric(31),
  v_state in numeric(31),
  v_trace in varchar(4000),
  v_cod_operation in varchar(4000),
  v_priority in numeric(31)
)
return numeric(31) is
-- operation 15 - Rimozione risorsa
  pr_rec          person_resource%ROWTYPE;

  counter         numeric(16);
  v_eventpm_attr5 numeric(16);

  v_acc_user_code varchar(256);
begin
  v_eventpm_attr5 := cast(v_eventpm.attr5 as numeric(31));

  --controlliamo se il person-resource cui ci si riferisce  stata cancellata
  select count(1)
    into counter
    from person_resource t
   where t.id = v_eventpm_attr5;

  if ( counter = 0 ) then
    return -1;
  end if;

  select t.entitlement_name,
         t.resource_name,
         t.resource_type_name,
         t.resource_fam_name
    into pr_rec.entitlement_name,
         pr_rec.resource_name,
         pr_rec.resource_type_name,
         pr_rec.resource_fam_name
    from person_resource t
   where t.id = v_eventpm_attr5;

  --non inseriamo eventi che riguardano risorse o ruoli cancellati prima che siano stati aggiornati
  if ( pr_rec.entitlement_name is null or pr_rec.resource_name is null or pr_rec.resource_type_name is null or pr_rec.resource_fam_name is null ) then
    return event_01_del_fb_per_res ( v_eventpm_attr5, v_eventpm.operation );
  end if;

  v_eventpm.attr1 := pr_rec.resource_name;
  v_eventpm.attr2 := pr_rec.resource_type_name;
  v_eventpm.attr3 := pr_rec.resource_fam_name;
  v_eventpm.attr4 := pr_rec.entitlement_name;

  --cancelliamo il person_resourc e controlliamo se la risorsa  asseganata all'utente attraverso altri ruoli
  delete from person_resource t where t.id = v_eventpm_attr5;

  --aggiorniamo il feedback
  update feedback
    set user_erc    = v_user_erc_id,
        funct       = pr_rec.resource_name,
        funct_type  = pr_rec.resource_type_name
  where authorizations = v_eventpm_attr5
    and operation = v_eventpm.operation;

  --controlliamo se la risorsa  asseganata all'utente attraverso altri ruoli
  select count(1)
    into counter
    from person_resource pr
   where pr.resourc = v_eventpm.entity
     and pr.person = v_eventpm.person;

  v_acc_user_code := event_02_user_acc_code ( v_eventpm.pwdcfg, v_eventpm.person );

  --non  pi necessario controllare che la risorsa in oggetto non sia la "ALL" poich
  --esse non sono presenti in person_resource
   if ( counter = 0 ) then
     return event_01_res_add_rem ( v_eventpm, v_user_erc_id, v_state, v_trace, v_cod_operation, v_priority, v_acc_user_code );
   else
     return -1;
   end if;
end event_11_res_rem;
/
